# Get the cloud database list - ListUPgSQLInstance

## Overview

Get PG Cloud Database List






## Definition

### Public Parameters

| Parameter Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Action**     | string  | Corresponding API command name, the current API is `ListUPgSQLInstance`.                      | **Yes** |
| **PublicKey**  | string  | The user's public key can be obtained from [Console](https://console.scloudsg.com/uaccount/api_manage)                                             | **Yes** |
| **Signature**  | string  | User signature generated based on public key and API command, see [Signature Algorithm](/docs/api/summary/signature.md)  | **Yes** |

### Request Parameters

| Parameter Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Region** | string | Region. See [List of Regions and Availability Zones](/docs/api/summary/regionlist) |**Yes**|
| **Zone** | string | Availability Zone. See [Availability Zone List](/docs/api/summary/regionlist) |No|
| **ProjectId** | string | Project ID. If not filled in, the default project is used, sub-accounts must be filled in. Please refer to the [GetProjectList interface](/docs/api/summary/get_project_list). |No|

### Response Field

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **RetCode** | int | Return status code. If it is 0, it means successful return. If it is not 0, it means failure. |**Yes**|
| **Action** | string | Operation command name. |**Yes**|
| **Message** | string | Returns an error message, providing detailed description when `RetCode` is non-zero. |No|
| **DataSet** | array[[*UDBInstanceSet*](#udbinstanceset)] | Database Information List |**Yes**|

#### Data Model


#### UDBInstanceSet

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Zone** | string | Availability Zone |No|
| **InstanceID** | string | Resource ID |No|
| **Name** | string | Instance Name |No|
| **DBVersion** | string | Version of the instance, including postgresql-10.4, postgresql-13.4 |No|
| **InstanceMode** | string | normal/ha/readonly, Normal/High Availability/Read-Only Slave |No|
| **State** | string | Instance status markers Initing: Initializing, InitFailed: Installation failed, Starting: Starting up, Running: Running, Stopping: Shutting down, Stopped: Stopped, Deleted: Deleted, Upgrading: Upgrading, Promoting: Promoting to master in progress, Recovering: Recovering, RecoverFailed: Recovery failed, StartFailed: Start-up failed, ShutdownFailed: Shutdown failed, Deleting: Deleting, DeleteFailed: Deletion failed |No|
| **MachineType** | string | Machine specifications, in the format of nCmG, where n represents the number of CPU cores, and m represents the size of memory (GB). |No|
| **VPCID** | string | ID of VPC |No|
| **SubnetID** | string | Subnet ID |No|
| **CreateTime** | int | DB instance creation time, using UTC timestamp |No|
| **ExpiredTime** | int | Expiration time of the DB instance, using UTC timestamp |No|
| **IP** | string | DB Instance IP |No|
| **Remark** | string | Note |No|
| **DataSet** | array[[*UDBReadonlyInstance*](#udbreadonlyinstance)] | Slave Database List |No|

#### UDBReadonlyInstance

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Zone** | string | Availability Zone |No|
| **InstanceID** | string | Resource ID |No|
| **Name** | string | Instance Name |No|
| **DBVersion** | string | Version of the instance, including postgresql-10.4, postgresql-13.4 |No|
| **InstanceMode** | string | normal/ha/readonly, Normal/High Availability/Read-Only Slave |No|
| **State** | string | Instance status markers Initing: Initializing, InitFailed: Installation failed, Starting: Starting up, Running: Running, Stopping: Shutting down, Stopped: Stopped, Deleted: Deleted, Upgrading: Upgrading, Promoting: Promoting to master in progress, Recovering: Recovering, RecoverFailed: Recovery failed, StartFailed: Start-up failed, ShutdownFailed: Shutdown failed, Deleting: Deleting, DeleteFailed: Deletion failed |No|
| **MachineType** | string | Machine specifications, in the format of nCmG, where n represents the number of CPU cores, and m represents the size of memory (GB). |No|
| **VPCID** | string | ID of VPC |No|
| **SubnetID** | string | Subnet ID |No|
| **CreateTime** | int | DB instance creation time, using UTC timestamp |No|
| **ExpiredTime** | int | Expiration time of the DB instance, using UTC timestamp |No|
| **IP** | string | DB Instance IP |No|
| **Remark** | string | Note |No|

## Example

### Request Example
    
```
https://api.scloudsg.com/?Action=ListUPgSQLInstance
&Region=cn-zj
&Zone=cn-zj-01
&ProjectId=xQTrvEtW
```

### Response Example
    
```json
{
  "Action": "ListUPgSQLInstanceResponse",
  "DataSet": [
    {
      "CreateTime": "LQiIDcUC",
      "DBVersion": "eSmGfTtw",
      "ExpiredTime": "QivusIMX",
      "IP": "jTZqgTRr",
      "InstanceID": "bPLlxURz",
      "InstanceMode": "hedJgcaN",
      "MachineType": "yuBcEIfJ",
      "Name": "dXrXuFJC",
      "State": "oTYEroYw",
      "SubnetID": "wohfomIJ",
      "VPCID": "bfgZFuLa",
      "Zone": "OYUfGKLT"
    }
  ],
  "Message": "nngXwSig",
  "RetCode": 0
}
```





